Index: drivers/filesystems/btrfs/fsctl.c
===================================================================
--- drivers/filesystems/btrfs/fsctl.c	(révision 75772)
+++ drivers/filesystems/btrfs/fsctl.c	(copie de travail)
@@ -740,127 +765,142 @@
     UINT64* root_num;
     file_ref *fr = NULL, *fr2;
     dir_child* dc = NULL;
-    
+
     fcb = FileObject->FsContext;
     if (!fcb) {
         ERR("error - fcb was NULL\n");
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     ccb = FileObject->FsContext2;
     if (!ccb) {
         ERR("error - ccb was NULL\n");
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     fileref = ccb->fileref;
-    
+
     if (fcb->type != BTRFS_TYPE_DIRECTORY) {
         ERR("parent FCB was not a directory\n");
         return STATUS_NOT_A_DIRECTORY;
     }
-    
+
     if (!fileref) {
         ERR("fileref was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     if (fileref->deleted || fcb->deleted) {
         ERR("parent has been deleted\n");
         return STATUS_FILE_DELETED;
     }
-    
+
     if (!(ccb->access & FILE_ADD_SUBDIRECTORY)) {
         WARN("insufficient privileges\n");
         return STATUS_ACCESS_DENIED;
     }
-    
-    if (fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY)
+
+    if (Vcb->readonly)
+        return STATUS_MEDIA_WRITE_PROTECTED;
+
+    if (is_subvol_readonly(fcb->subvol, Irp))
         return STATUS_ACCESS_DENIED;
-    
-    nameus.Length = nameus.MaximumLength = length;
-    nameus.Buffer = name;
-    
-    if (!is_file_name_valid(&nameus))
+
+    if (fcb == Vcb->dummy_fcb)
+        return STATUS_ACCESS_DENIED;
+
+    if (!data || datalen < sizeof(btrfs_create_subvol))
+        return STATUS_INVALID_PARAMETER;
+
+    bcs = (btrfs_create_subvol*)data;
+
+    if (offsetof(btrfs_create_subvol, name[0]) + bcs->namelen > datalen)
+        return STATUS_INVALID_PARAMETER;
+
+    nameus.Length = nameus.MaximumLength = bcs->namelen;
+    nameus.Buffer = bcs->name;
+
+    if (!is_file_name_valid(&nameus, bcs->posix))
         return STATUS_OBJECT_NAME_INVALID;
-    
+
     utf8.Buffer = NULL;
-    
-    Status = RtlUnicodeToUTF8N(NULL, 0, &len, name, length);
+
+    Status = RtlUnicodeToUTF8N(NULL, 0, &len, nameus.Buffer, nameus.Length);
     if (!NT_SUCCESS(Status)) {
         ERR("RtlUnicodeToUTF8N failed with error %08x\n", Status);
         return Status;
     }
-    
+
     if (len == 0) {
         ERR("RtlUnicodeToUTF8N returned a length of 0\n");
         return STATUS_INTERNAL_ERROR;
     }
-    
-    utf8.MaximumLength = utf8.Length = len;
+
+    if (len > 0xffff) {
+        ERR("len was too long\n");
+        return STATUS_INVALID_PARAMETER;
+    }
+
+    utf8.MaximumLength = utf8.Length = (USHORT)len;
     utf8.Buffer = ExAllocatePoolWithTag(PagedPool, utf8.Length, ALLOC_TAG);
-    
+
     if (!utf8.Buffer) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
-    Status = RtlUnicodeToUTF8N(utf8.Buffer, len, &len, name, length);
+
+    Status = RtlUnicodeToUTF8N(utf8.Buffer, len, &len, nameus.Buffer, nameus.Length);
     if (!NT_SUCCESS(Status)) {
         ERR("RtlUnicodeToUTF8N failed with error %08x\n", Status);
         goto end2;
     }
-    
+
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-    
+
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
-    
-    InitializeListHead(&rollback);
-    
+
     // no need for fcb_lock as we have tree_lock exclusively
-    Status = open_fileref(fcb->Vcb, &fr2, &nameus, fileref, FALSE, NULL, NULL, PagedPool, FALSE, Irp);
-    
+    Status = open_fileref(fcb->Vcb, &fr2, &nameus, fileref, FALSE, NULL, NULL, PagedPool, ccb->case_sensitive || bcs->posix, Irp);
+
     if (NT_SUCCESS(Status)) {
         if (!fr2->deleted) {
             WARN("file already exists\n");
-            free_fileref(fr2);
+            free_fileref(Vcb, fr2);
             Status = STATUS_OBJECT_NAME_COLLISION;
             goto end;
         } else
-            free_fileref(fr2);
+            free_fileref(Vcb, fr2);
     } else if (!NT_SUCCESS(Status) && Status != STATUS_OBJECT_NAME_NOT_FOUND) {
         ERR("open_fileref returned %08x\n", Status);
         goto end;
     }
-    
-    // FIXME - make sure rollback removes new roots from internal structures
-    
+
     id = InterlockedIncrement64(&Vcb->root_root->lastinode);
-    Status = create_root(Vcb, id, &r, FALSE, 0, Irp, &rollback);
-    
+    Status = create_root(Vcb, id, &r, FALSE, 0, Irp);
+
     if (!NT_SUCCESS(Status)) {
         ERR("create_root returned %08x\n", Status);
         goto end;
     }
-    
+
     TRACE("created root %llx\n", id);
-    
+
     if (!Vcb->uuid_root) {
         root* uuid_root;
-        
+
         TRACE("uuid root doesn't exist, creating it\n");
-        
-        Status = create_root(Vcb, BTRFS_ROOT_UUID, &uuid_root, FALSE, 0, Irp, &rollback);
-        
+
+        Status = create_root(Vcb, BTRFS_ROOT_UUID, &uuid_root, FALSE, 0, Irp);
+
         if (!NT_SUCCESS(Status)) {
             ERR("create_root returned %08x\n", Status);
             goto end;
         }
-        
+
         Vcb->uuid_root = uuid_root;
     }
-    
+
     root_num = ExAllocatePoolWithTag(PagedPool, sizeof(UINT64), ALLOC_TAG);
     if (!root_num) {
         ERR("out of memory\n");
@@ -867,27 +907,28 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     tp.tree = NULL;
-    
+
     do {
         get_uuid(&r->root_item.uuid);
-        
+
         RtlCopyMemory(&searchkey.obj_id, &r->root_item.uuid, sizeof(UINT64));
         searchkey.obj_type = TYPE_SUBVOL_UUID;
         RtlCopyMemory(&searchkey.offset, &r->root_item.uuid.uuid[sizeof(UINT64)], sizeof(UINT64));
-        
+
         Status = find_item(Vcb, Vcb->uuid_root, &tp, &searchkey, FALSE, Irp);
     } while (NT_SUCCESS(Status) && !keycmp(searchkey, tp.item->key));
-    
+
     *root_num = r->id;
-    
-    if (!insert_tree_item(Vcb, Vcb->uuid_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, root_num, sizeof(UINT64), NULL, Irp, &rollback)) {
-        ERR("insert_tree_item failed\n");
-        Status = STATUS_INTERNAL_ERROR;
+
+    Status = insert_tree_item(Vcb, Vcb->uuid_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, root_num, sizeof(UINT64), NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
+        ExFreePool(root_num);
         goto end;
     }
-    
+
     r->root_item.inode.generation = 1;
     r->root_item.inode.st_size = 3;
     r->root_item.inode.st_blocks = Vcb->superblock.node_size;
@@ -894,7 +935,10 @@
     r->root_item.inode.st_nlink = 1;
     r->root_item.inode.st_mode = __S_IFDIR | S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH; // 40755
     r->root_item.inode.flags = 0xffffffff80000000; // FIXME - find out what these mean
-    
+
+    if (bcs->readonly)
+        r->root_item.flags |= BTRFS_SUBVOL_READONLY;
+
     r->root_item.objid = SUBVOL_ROOT_INODE;
     r->root_item.bytes_used = Vcb->superblock.node_size;
     r->root_item.ctransid = Vcb->superblock.generation;
@@ -901,55 +945,61 @@
     r->root_item.otransid = Vcb->superblock.generation;
     r->root_item.ctime = now;
     r->root_item.otime = now;
-    
+
     // add .. inode to new subvol
-    
-    rootfcb = create_fcb(PagedPool);
+
+    rootfcb = create_fcb(Vcb, PagedPool);
     if (!rootfcb) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     rootfcb->Vcb = Vcb;
-    
+
     rootfcb->subvol = r;
     rootfcb->inode = SUBVOL_ROOT_INODE;
     rootfcb->type = BTRFS_TYPE_DIRECTORY;
-    
+
     rootfcb->inode_item.generation = Vcb->superblock.generation;
     rootfcb->inode_item.transid = Vcb->superblock.generation;
     rootfcb->inode_item.st_nlink = 1;
-    rootfcb->inode_item.st_mode = __S_IFDIR | S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH; // 40755
+    rootfcb->inode_item.st_mode = __S_IFDIR | inherit_mode(fileref->fcb, TRUE);
     rootfcb->inode_item.st_atime = rootfcb->inode_item.st_ctime = rootfcb->inode_item.st_mtime = rootfcb->inode_item.otime = now;
-    rootfcb->inode_item.st_gid = GID_NOBODY; // FIXME?
-    
-    rootfcb->atts = get_file_attributes(Vcb, &rootfcb->inode_item, rootfcb->subvol, rootfcb->inode, rootfcb->type, FALSE, TRUE, Irp);
-    
+    rootfcb->inode_item.st_gid = GID_NOBODY;
+
+    rootfcb->atts = get_file_attributes(Vcb, rootfcb->subvol, rootfcb->inode, rootfcb->type, FALSE, TRUE, Irp);
+
+    if (r->root_item.flags & BTRFS_SUBVOL_READONLY)
+        rootfcb->atts |= FILE_ATTRIBUTE_READONLY;
+
     SeCaptureSubjectContext(&subjcont);
-    
+
     Status = SeAssignSecurity(fcb->sd, NULL, (void**)&rootfcb->sd, TRUE, &subjcont, IoGetFileObjectGenericMapping(), PagedPool);
-    
+
     if (!NT_SUCCESS(Status)) {
         ERR("SeAssignSecurity returned %08x\n", Status);
         goto end;
     }
-    
+
     if (!rootfcb->sd) {
         ERR("SeAssignSecurity returned NULL security descriptor\n");
         Status = STATUS_INTERNAL_ERROR;
         goto end;
     }
-    
+
     Status = RtlGetOwnerSecurityDescriptor(rootfcb->sd, &owner, &defaulted);
     if (!NT_SUCCESS(Status)) {
         ERR("RtlGetOwnerSecurityDescriptor returned %08x\n", Status);
         rootfcb->inode_item.st_uid = UID_NOBODY;
+        rootfcb->sd_dirty = TRUE;
     } else {
         rootfcb->inode_item.st_uid = sid_to_uid(owner);
+        rootfcb->sd_dirty = rootfcb->inode_item.st_uid == UID_NOBODY;
     }
-    
-    rootfcb->sd_dirty = TRUE;
+
+    find_gid(rootfcb, fileref->fcb, &subjcont);
+
     rootfcb->inode_item_changed = TRUE;
 
     ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
@@ -956,19 +1006,25 @@
     InsertTailList(&r->fcbs, &rootfcb->list_entry);
     InsertTailList(&Vcb->all_fcbs, &rootfcb->list_entry_all);
     ExReleaseResourceLite(&Vcb->fcb_lock);
-    
+
     rootfcb->Header.IsFastIoPossible = fast_io_possible(rootfcb);
     rootfcb->Header.AllocationSize.QuadPart = 0;
     rootfcb->Header.FileSize.QuadPart = 0;
     rootfcb->Header.ValidDataLength.QuadPart = 0;
-    
+
     rootfcb->created = TRUE;
-    
+
+    if (fileref->fcb->inode_item.flags & BTRFS_INODE_COMPRESS)
+        rootfcb->inode_item.flags |= BTRFS_INODE_COMPRESS;
+
+    rootfcb->prop_compression = fileref->fcb->prop_compression;
+    rootfcb->prop_compression_changed = rootfcb->prop_compression != PropCompression_None;
+
     r->lastinode = rootfcb->inode;
-    
+
     // add INODE_REF
-    
-    irsize = sizeof(INODE_REF) - 1 + strlen(DOTDOT);
+
+    irsize = (UINT16)(offsetof(INODE_REF, name[0]) + strlen(DOTDOT));
     ir = ExAllocatePoolWithTag(PagedPool, irsize, ALLOC_TAG);
     if (!ir) {
         ERR("out of memory\n");
@@ -975,153 +1031,135 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     ir->index = 0;
-    ir->n = strlen(DOTDOT);
+    ir->n = (USHORT)strlen(DOTDOT);
     RtlCopyMemory(ir->name, DOTDOT, ir->n);
 
-    if (!insert_tree_item(Vcb, r, r->root_item.objid, TYPE_INODE_REF, r->root_item.objid, ir, irsize, NULL, Irp, &rollback)) {
-        ERR("insert_tree_item failed\n");
-        Status = STATUS_INTERNAL_ERROR;
+    Status = insert_tree_item(Vcb, r, r->root_item.objid, TYPE_INODE_REF, r->root_item.objid, ir, irsize, NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
+        ExFreePool(ir);
         goto end;
     }
-    
+
     // create fileref for entry in other subvolume
-    
-    fr = create_fileref();
+
+    fr = create_fileref(Vcb);
     if (!fr) {
         ERR("out of memory\n");
-        
+
         ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fcb(rootfcb);
+        free_fcb(Vcb, rootfcb);
         ExReleaseResourceLite(&Vcb->fcb_lock);
-        
+
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     fr->fcb = rootfcb;
-    
+
     mark_fcb_dirty(rootfcb);
-    
-    Status = fcb_get_last_dir_index(fcb, &dirpos, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("fcb_get_last_dir_index returned %08x\n", Status);
-        ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fileref(fr);
-        ExReleaseResourceLite(&Vcb->fcb_lock);
-        goto end;
-    }
-    
-    fr->index = dirpos;
-    fr->utf8 = utf8;
-    
-    fr->filepart.MaximumLength = fr->filepart.Length = nameus.Length;
-    fr->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, fr->filepart.MaximumLength, ALLOC_TAG);
-    if (!fr->filepart.Buffer) {
-        ERR("out of memory\n");
-        ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fileref(fr);
-        ExReleaseResourceLite(&Vcb->fcb_lock);
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    RtlCopyMemory(fr->filepart.Buffer, nameus.Buffer, nameus.Length);
-    
-    Status = RtlUpcaseUnicodeString(&fr->filepart_uc, &fr->filepart, TRUE);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fileref(fr);
-        ExReleaseResourceLite(&Vcb->fcb_lock);
-        goto end;
-    }
-    
+
     fr->parent = fileref;
-    
-    Status = add_dir_child(fileref->fcb, r->id, TRUE, dirpos, &utf8, &fr->filepart, &fr->filepart_uc, BTRFS_TYPE_DIRECTORY, &dc);
+
+    Status = add_dir_child(fileref->fcb, r->id, TRUE, &utf8, &nameus, BTRFS_TYPE_DIRECTORY, &dc);
     if (!NT_SUCCESS(Status))
         WARN("add_dir_child returned %08x\n", Status);
-    
+
     fr->dc = dc;
     dc->fileref = fr;
-    
+
     fr->fcb->hash_ptrs = ExAllocatePoolWithTag(PagedPool, sizeof(LIST_ENTRY*) * 256, ALLOC_TAG);
     if (!fr->fcb->hash_ptrs) {
         ERR("out of memory\n");
         ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fileref(fr);
+        free_fileref(Vcb, fr);
         ExReleaseResourceLite(&Vcb->fcb_lock);
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     RtlZeroMemory(fr->fcb->hash_ptrs, sizeof(LIST_ENTRY*) * 256);
-    
+
     fr->fcb->hash_ptrs_uc = ExAllocatePoolWithTag(PagedPool, sizeof(LIST_ENTRY*) * 256, ALLOC_TAG);
-    if (!fcb->hash_ptrs_uc) {
+    if (!fr->fcb->hash_ptrs_uc) {
         ERR("out of memory\n");
         ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fileref(fr);
+        free_fileref(Vcb, fr);
         ExReleaseResourceLite(&Vcb->fcb_lock);
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     RtlZeroMemory(fr->fcb->hash_ptrs_uc, sizeof(LIST_ENTRY*) * 256);
-    
-    insert_fileref_child(fileref, fr, TRUE);
+
+    ExAcquireResourceExclusiveLite(&fileref->nonpaged->children_lock, TRUE);
+    InsertTailList(&fileref->children, &fr->list_entry);
+    ExReleaseResourceLite(&fileref->nonpaged->children_lock);
+
     increase_fileref_refcount(fileref);
-    
+
     if (fr->fcb->type == BTRFS_TYPE_DIRECTORY)
         fr->fcb->fileref = fr;
-    
+
     fr->created = TRUE;
     mark_fileref_dirty(fr);
-    
+
     // change fcb->subvol's ROOT_ITEM
-    
+
     fcb->subvol->root_item.ctransid = Vcb->superblock.generation;
     fcb->subvol->root_item.ctime = now;
-    
+
     // change fcb's INODE_ITEM
-    
+
     fcb->inode_item.transid = Vcb->superblock.generation;
     fcb->inode_item.st_size += utf8.Length * 2;
     fcb->inode_item.sequence++;
-    
+
     if (!ccb->user_set_change_time)
         fcb->inode_item.st_ctime = now;
-    
+
     if (!ccb->user_set_write_time)
         fcb->inode_item.st_mtime = now;
-    
+
     fcb->inode_item_changed = TRUE;
     mark_fcb_dirty(fcb);
-    
-    Status = STATUS_SUCCESS;    
-    
+
+    fr->fcb->subvol->parent = fcb->subvol->id;
+
+    Status = STATUS_SUCCESS;
+
 end:
-    if (!NT_SUCCESS(Status))
-        do_rollback(Vcb, &rollback);
-    else
-        clear_rollback(Vcb, &rollback);
-    
+    if (!NT_SUCCESS(Status)) {
+        if (fr) {
+            fr->deleted = TRUE;
+            mark_fileref_dirty(fr);
+        } else if (rootfcb) {
+            rootfcb->deleted = TRUE;
+            mark_fcb_dirty(rootfcb);
+        }
+
+        if (r) {
+            RemoveEntryList(&r->list_entry);
+            InsertTailList(&Vcb->drop_roots, &r->list_entry);
+        }
+    }
+
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     if (NT_SUCCESS(Status)) {
-        send_notification_fileref(fr, FILE_NOTIFY_CHANGE_DIR_NAME, FILE_ACTION_ADDED);
-        send_notification_fileref(fr->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
+        send_notification_fileref(fr, FILE_NOTIFY_CHANGE_DIR_NAME, FILE_ACTION_ADDED, NULL);
+        send_notification_fileref(fr->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED, NULL);
     }
-    
+
 end2:
     if (fr) {
         ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fileref(fr);
+        free_fileref(Vcb, fr);
         ExReleaseResourceLite(&Vcb->fcb_lock);
     }
-        
+
     return Status;
 }
 
@@ -1129,30 +1167,33 @@
     btrfs_inode_info* bii = data;
     fcb* fcb;
     ccb* ccb;
-    
+
     if (length < sizeof(btrfs_inode_info))
         return STATUS_BUFFER_OVERFLOW;
-    
+
     if (!FileObject)
         return STATUS_INVALID_PARAMETER;
-    
+
     fcb = FileObject->FsContext;
-    
+
     if (!fcb)
         return STATUS_INVALID_PARAMETER;
-    
+
     ccb = FileObject->FsContext2;
-    
+
     if (!ccb)
         return STATUS_INVALID_PARAMETER;
-    
+
     if (!(ccb->access & FILE_READ_ATTRIBUTES)) {
         WARN("insufficient privileges\n");
         return STATUS_ACCESS_DENIED;
     }
-    
+
+    if (fcb->ads)
+        fcb = ccb->fileref->parent->fcb;
+
     ExAcquireResourceSharedLite(fcb->Header.Resource, TRUE);
-    
+
     bii->subvol = fcb->subvol->id;
     bii->inode = fcb->inode;
     bii->top = fcb->Vcb->root_fileref->fcb == fcb ? TRUE : FALSE;
@@ -1160,88 +1201,113 @@
     bii->st_uid = fcb->inode_item.st_uid;
     bii->st_gid = fcb->inode_item.st_gid;
     bii->st_mode = fcb->inode_item.st_mode;
-    bii->st_rdev = fcb->inode_item.st_rdev;
+
+    if (fcb->inode_item.st_rdev == 0)
+        bii->st_rdev = 0;
+    else
+        bii->st_rdev = makedev((fcb->inode_item.st_rdev & 0xFFFFFFFFFFF) >> 20, fcb->inode_item.st_rdev & 0xFFFFF);
+
     bii->flags = fcb->inode_item.flags;
-    
+
     bii->inline_length = 0;
     bii->disk_size[0] = 0;
     bii->disk_size[1] = 0;
     bii->disk_size[2] = 0;
-    
+
     if (fcb->type != BTRFS_TYPE_DIRECTORY) {
         LIST_ENTRY* le;
-        
+
         le = fcb->extents.Flink;
         while (le != &fcb->extents) {
             extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-            
+
             if (!ext->ignore) {
-                if (ext->data->type == EXTENT_TYPE_INLINE) {
-                    bii->inline_length += ext->data->decoded_size;
+                if (ext->extent_data.type == EXTENT_TYPE_INLINE) {
+                    bii->inline_length += ext->datalen - (UINT16)offsetof(EXTENT_DATA, data[0]);
                 } else {
-                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
-                    
+                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
+
                     // FIXME - compressed extents with a hole in them are counted more than once
                     if (ed2->size != 0) {
-                        if (ext->data->compression == BTRFS_COMPRESSION_NONE) {
+                        if (ext->extent_data.compression == BTRFS_COMPRESSION_NONE) {
                             bii->disk_size[0] += ed2->num_bytes;
-                        } else if (ext->data->compression == BTRFS_COMPRESSION_ZLIB) {
+                        } else if (ext->extent_data.compression == BTRFS_COMPRESSION_ZLIB) {
                             bii->disk_size[1] += ed2->size;
-                        } else if (ext->data->compression == BTRFS_COMPRESSION_LZO) {
+                        } else if (ext->extent_data.compression == BTRFS_COMPRESSION_LZO) {
                             bii->disk_size[2] += ed2->size;
                         }
                     }
                 }
             }
-            
+
             le = le->Flink;
         }
     }
-    
+
+    switch (fcb->prop_compression) {
+        case PropCompression_Zlib:
+            bii->compression_type = BTRFS_COMPRESSION_ZLIB;
+        break;
+
+        case PropCompression_LZO:
+            bii->compression_type = BTRFS_COMPRESSION_LZO;
+        break;
+
+        default:
+            bii->compression_type = BTRFS_COMPRESSION_ANY;
+        break;
+    }
+
     ExReleaseResourceLite(fcb->Header.Resource);
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS set_inode_info(PFILE_OBJECT FileObject, void* data, ULONG length) {
+static NTSTATUS set_inode_info(PFILE_OBJECT FileObject, void* data, ULONG length, PIRP Irp) {
     btrfs_set_inode_info* bsii = data;
     NTSTATUS Status;
     fcb* fcb;
     ccb* ccb;
-    
+
     if (length < sizeof(btrfs_set_inode_info))
-        return STATUS_BUFFER_OVERFLOW;
-    
+        return STATUS_INVALID_PARAMETER;
+
     if (!FileObject)
         return STATUS_INVALID_PARAMETER;
-    
+
     fcb = FileObject->FsContext;
-    
+
     if (!fcb)
         return STATUS_INVALID_PARAMETER;
-    
+
     ccb = FileObject->FsContext2;
-    
+
     if (!ccb)
         return STATUS_INVALID_PARAMETER;
-    
+
     if (bsii->flags_changed && !(ccb->access & FILE_WRITE_ATTRIBUTES)) {
         WARN("insufficient privileges\n");
         return STATUS_ACCESS_DENIED;
     }
-    
-    if (bsii->mode_changed && !(ccb->access & WRITE_DAC)) {
+
+    if ((bsii->mode_changed || bsii->uid_changed || bsii->gid_changed) && !(ccb->access & WRITE_DAC)) {
         WARN("insufficient privileges\n");
         return STATUS_ACCESS_DENIED;
     }
-    
-    if ((bsii->uid_changed || bsii->gid_changed) && !(ccb->access & WRITE_OWNER)) {
-        WARN("insufficient privileges\n");
+
+    if (bsii->compression_type_changed && bsii->compression_type > BTRFS_COMPRESSION_LZO)
+        return STATUS_INVALID_PARAMETER;
+
+    if (fcb->ads)
+        fcb = ccb->fileref->parent->fcb;
+
+    if (is_subvol_readonly(fcb->subvol, Irp)) {
+        WARN("trying to change inode on readonly subvolume\n");
         return STATUS_ACCESS_DENIED;
     }
-    
+
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
+
     if (bsii->flags_changed) {
         if (fcb->type != BTRFS_TYPE_DIRECTORY && fcb->inode_item.st_size > 0 &&
             (bsii->flags & BTRFS_INODE_NODATACOW) != (fcb->inode_item.flags & BTRFS_INODE_NODATACOW)) {
@@ -1249,74 +1315,64 @@
             Status = STATUS_INVALID_PARAMETER;
             goto end;
         }
-        
+
         fcb->inode_item.flags = bsii->flags;
-        
+
         if (fcb->inode_item.flags & BTRFS_INODE_NODATACOW)
             fcb->inode_item.flags |= BTRFS_INODE_NODATASUM;
-        else 
+        else
             fcb->inode_item.flags &= ~(UINT64)BTRFS_INODE_NODATASUM;
     }
-    
+
     if (bsii->mode_changed) {
-        UINT32 allowed = S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH;
-        
+        UINT32 allowed = S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IWGRP | S_IXGRP | S_IROTH | S_IWOTH | S_IXOTH |
+                         S_ISGID | S_ISVTX;
+
+        if (ccb->access & WRITE_OWNER)
+            allowed |= S_ISUID;
+
         fcb->inode_item.st_mode &= ~allowed;
         fcb->inode_item.st_mode |= bsii->st_mode & allowed;
     }
-    
-    if (bsii->uid_changed) {
-        PSID sid; 
-        SECURITY_INFORMATION secinfo;
-        SECURITY_DESCRIPTOR sd;
-        void* oldsd;
-        
+
+    if (bsii->uid_changed && fcb->inode_item.st_uid != bsii->st_uid) {
         fcb->inode_item.st_uid = bsii->st_uid;
-        
-        uid_to_sid(bsii->st_uid, &sid);
-        
-        Status = RtlCreateSecurityDescriptor(&sd, SECURITY_DESCRIPTOR_REVISION);
-        if (!NT_SUCCESS(Status)) {
-            ERR("RtlCreateSecurityDescriptor returned %08x\n", Status);
-            goto end;
-        }
-        
-        Status = RtlSetOwnerSecurityDescriptor(&sd, sid, FALSE);
-        if (!NT_SUCCESS(Status)) {
-            ERR("RtlSetOwnerSecurityDescriptor returned %08x\n", Status);
-            goto end;
-        }
-        
-        oldsd = fcb->sd;
-        
-        secinfo = OWNER_SECURITY_INFORMATION;
-        Status = SeSetSecurityDescriptorInfoEx(NULL, &secinfo, &sd, (void**)&fcb->sd, SEF_AVOID_PRIVILEGE_CHECK, PagedPool, IoGetFileObjectGenericMapping());
-        
-        if (!NT_SUCCESS(Status)) {
-            ERR("SeSetSecurityDescriptorInfo returned %08x\n", Status);
-            goto end;
-        }
-        
-        ExFreePool(oldsd);
-        
+
         fcb->sd_dirty = TRUE;
-        
-        send_notification_fcb(ccb->fileref, FILE_NOTIFY_CHANGE_SECURITY, FILE_ACTION_MODIFIED);
+        fcb->sd_deleted = FALSE;
     }
-    
+
     if (bsii->gid_changed)
         fcb->inode_item.st_gid = bsii->st_gid;
-    
-    if (bsii->flags_changed || bsii->mode_changed || bsii->uid_changed || bsii->gid_changed) {
+
+    if (bsii->compression_type_changed) {
+        switch (bsii->compression_type) {
+            case BTRFS_COMPRESSION_ANY:
+                fcb->prop_compression = PropCompression_None;
+            break;
+
+            case BTRFS_COMPRESSION_ZLIB:
+                fcb->prop_compression = PropCompression_Zlib;
+            break;
+
+            case BTRFS_COMPRESSION_LZO:
+                fcb->prop_compression = PropCompression_LZO;
+            break;
+        }
+
+        fcb->prop_compression_changed = TRUE;
+    }
+
+    if (bsii->flags_changed || bsii->mode_changed || bsii->uid_changed || bsii->gid_changed || bsii->compression_type_changed) {
         fcb->inode_item_changed = TRUE;
         mark_fcb_dirty(fcb);
     }
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     ExReleaseResourceLite(fcb->Header.Resource);
-    
+
     return Status;
 }
 
@@ -1324,19 +1380,19 @@
     btrfs_device* dev = NULL;
     NTSTATUS Status;
     LIST_ENTRY* le;
-    
+
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-    
+
     le = Vcb->devices.Flink;
     while (le != &Vcb->devices) {
         device* dev2 = CONTAINING_RECORD(le, device, list_entry);
         ULONG structlen;
-        
+
         if (length < sizeof(btrfs_device) - sizeof(WCHAR)) {
             Status = STATUS_BUFFER_OVERFLOW;
             goto end;
         }
-        
+
         if (!dev)
             dev = data;
         else {
@@ -1343,63 +1399,99 @@
             dev->next_entry = sizeof(btrfs_device) - sizeof(WCHAR) + dev->namelen;
             dev = (btrfs_device*)((UINT8*)dev + dev->next_entry);
         }
-        
+
         structlen = length - offsetof(btrfs_device, namelen);
-        
-        Status = dev_ioctl(dev2->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &dev->namelen, structlen, TRUE, NULL);
-        if (!NT_SUCCESS(Status))
-            goto end;
-        
+
+        if (dev2->devobj) {
+            Status = dev_ioctl(dev2->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &dev->namelen, structlen, TRUE, NULL);
+            if (!NT_SUCCESS(Status))
+                goto end;
+
+            dev->missing = FALSE;
+        } else {
+            dev->namelen = 0;
+            dev->missing = TRUE;
+        }
+
         dev->next_entry = 0;
         dev->dev_id = dev2->devitem.dev_id;
-        dev->size = dev2->length;
         dev->readonly = (Vcb->readonly || dev2->readonly) ? TRUE : FALSE;
         dev->device_number = dev2->disk_num;
         dev->partition_number = dev2->part_num;
-        
+        dev->size = dev2->devitem.num_bytes;
+
+        if (dev2->devobj) {
+            GET_LENGTH_INFORMATION gli;
+
+            Status = dev_ioctl(dev2->devobj, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0, &gli, sizeof(gli), TRUE, NULL);
+            if (!NT_SUCCESS(Status))
+                goto end;
+
+            dev->max_size = gli.Length.QuadPart;
+        } else
+            dev->max_size = dev->size;
+
+        RtlCopyMemory(dev->stats, dev2->stats, sizeof(UINT64) * 5);
+
         length -= sizeof(btrfs_device) - sizeof(WCHAR) + dev->namelen;
-        
+
         le = le->Flink;
     }
 
 end:
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     return Status;
 }
 
-static NTSTATUS get_usage(device_extension* Vcb, void* data, ULONG length) {
+static NTSTATUS get_usage(device_extension* Vcb, void* data, ULONG length, PIRP Irp) {
     btrfs_usage* usage = (btrfs_usage*)data;
     btrfs_usage* lastbue = NULL;
     NTSTATUS Status;
     LIST_ENTRY* le;
-    
+
     if (length < sizeof(btrfs_usage))
         return STATUS_BUFFER_OVERFLOW;
-    
+
+    if (!Vcb->chunk_usage_found) {
+        ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
+
+        if (!Vcb->chunk_usage_found)
+            Status = find_chunk_usage(Vcb, Irp);
+        else
+            Status = STATUS_SUCCESS;
+
+        ExReleaseResourceLite(&Vcb->tree_lock);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("find_chunk_usage returned %08x\n", Status);
+            return Status;
+        }
+    }
+
     length -= offsetof(btrfs_usage, devices);
-    
+
     ExAcquireResourceSharedLite(&Vcb->chunk_lock, TRUE);
-    
+
     le = Vcb->chunks.Flink;
     while (le != &Vcb->chunks) {
         BOOL addnew = FALSE;
-        
+
         chunk* c = CONTAINING_RECORD(le, chunk, list_entry);
-        
+
         if (!lastbue) // first entry
             addnew = TRUE;
         else {
             btrfs_usage* bue = usage;
-            
+
             addnew = TRUE;
-            
+
             while (TRUE) {
                 if (bue->type == c->chunk_item->type) {
                     addnew = FALSE;
                     break;
                 }
-                
+
                 if (bue->next_entry == 0)
                     break;
                 else
@@ -1406,12 +1498,12 @@
                     bue = (btrfs_usage*)((UINT8*)bue + bue->next_entry);
             }
         }
-        
+
         if (addnew) {
             btrfs_usage* bue;
             LIST_ENTRY* le2;
             UINT64 factor;
-            
+
             if (!lastbue) {
                 bue = usage;
             } else {
@@ -1419,20 +1511,20 @@
                     Status = STATUS_BUFFER_OVERFLOW;
                     goto end;
                 }
-                
+
                 length -= offsetof(btrfs_usage, devices);
-                
-                lastbue->next_entry = offsetof(btrfs_usage, devices) + (lastbue->num_devices * sizeof(btrfs_usage_device));
-                
+
+                lastbue->next_entry = offsetof(btrfs_usage, devices) + (ULONG)(lastbue->num_devices * sizeof(btrfs_usage_device));
+
                 bue = (btrfs_usage*)((UINT8*)lastbue + lastbue->next_entry);
             }
-            
+
             bue->next_entry = 0;
             bue->type = c->chunk_item->type;
             bue->size = 0;
             bue->used = 0;
             bue->num_devices = 0;
-            
+
             if (c->chunk_item->type & BLOCK_FLAG_RAID0)
                 factor = c->chunk_item->num_stripes;
             else if (c->chunk_item->type & BLOCK_FLAG_RAID10)
